pub const FC_ENABLE :u32 = 0x0000_0001;

#[derive(Clone, Copy)]
pub struct UserStatus {
    pub await_flags:u32,
}
impl UserStatus {
    pub fn new() -> Self
    {
        Self {
            await_flags:0,
        }
    }
}

#[derive(Clone)]
pub struct UserStatistics {
    pub games_played:u32,
    pub games_won:u32,
}
impl UserStatistics {
    pub fn new() -> Self
    {
        Self {
            games_played:0,
            games_won:0,
        }
    }
}

#[derive(Clone)]
pub struct User {
    pub id:u32,
    pub flags:u32,
    pub handle:String,
    pub secret:Vec<u8>,
    pub na_key:u32,

    pub connection:Option<u32>,
    
    pub status:UserStatus,
    pub statistics:UserStatistics,

    pub challenges:Vec<u32>,
}
impl User {
    pub fn new() -> Self
    {
        Self {
            id:0,
            flags:0,
            handle:String::new(),
            secret:Vec::new(),
            na_key:0,

            connection:None,

            status:UserStatus::new(),
            statistics:UserStatistics::new(),

            challenges:Vec::new(),
        }
    }
}
